Leetcode:645. 错误的集合——Java暴力解法&哈希表法

题目------Leetcode:645. 错误的集合

集合 s 包含从 1 到 n 的整数。不幸的是,因为数据错误,导致集合里面某一个数字复制了成了集合里面的另外一个数字的值,导致集合 丢失了一个数字 并且 有一个数字重复 。

给定一个数组 nums 代表了集合 S 发生错误后的结果。

请你找出重复出现的整数,再找到丢失的整数,将它们以数组的形式返回
示例 1:

复制代码
输入:nums = [1,2,2,4]
输出:[2,3]

示例 2:

复制代码
输入:nums = [1,1]
输出:[1,2]

题目分析:

这个题目有很多个陷阱需要注意。首先,题目中未说明nums数组是按照有序的顺序给出的。所以我们使用暴力解法时,一定要先排序,后做判断。 其次,要注意特殊情况,即要判断丢失数据是否是1或者n。

方法一:暴力解法

java 复制代码
class Solution {
    public int[] findErrorNums(int[] nums) {
        int ln = nums.length;
        int repeat = -1, lose = -1;
        
        // 对数组进行排序
        Arrays.sort(nums);
        
        // 检查数组的第一个元素是否不等于1,如果是,则缺失的数字是1
        if (nums[0] != 1) {
            lose = 1;
        } 
        // 检查数组的最后一个元素是否不等于数组长度,如果是,则缺失的数字是数组长度
        else if (nums[ln - 1] != ln) {
            lose = ln;
        }
        
        // 遍历数组,找出重复的数字和缺失的数字之间的空隙
        for (int i = 1; i < ln; i++) {
            // 如果当前元素与前一个元素相等,则找到了重复的数字
            if (nums[i] == nums[i - 1]) {
                repeat = nums[i];
            }
            // 如果当前元素与前一个元素的差为2,则缺失的数字是这两个数之间的那个数
            if (nums[i] - nums[i - 1] == 2) {
                lose = nums[i] - 1;
            }
        }
        
        // 返回包含重复数字和缺失数字的数组
        return new int[]{repeat, lose};
    }
}
  • 时间复杂度:O(nlogn)
  • 空间复杂度:最坏情况下 O(n),但可能依赖于具体实现的排序算法。

方法二:哈希表法

哈希表要比方法一更简单容易理解一些。我们把数组中的数字都存入哈希表中。

我们知道,重复的数字在数组中出现 2 次,丢失的数字在数组中出现 0 次,其余的每个数字在数组中出现 1 次。因此可以使用哈希表记录每个元素在数组中出现的次数,然后遍历从 1 到 n 的每个数字,分别找到出现 2 次和出现 0 次的数字,即为重复的数字和丢失的数字。

java 复制代码
class Solution {
    public int[] findErrorNums(int[] nums) {
        // 用于存储错误数字的数组
        int[] errorNums = new int[2];
        // 获取数组的长度
        int n = nums.length;
        // 使用HashMap来记录每个数字出现的次数
        Map<Integer, Integer> map = new HashMap<Integer, Integer>();

        // 遍历数组,统计每个数字的出现次数
        for (int num : nums) {
            map.put(num, map.getOrDefault(num, 0) + 1);
        }

        // 遍历从1到n的每个数字,找出重复和缺失的数字
        for (int i = 1; i <= n; i++) {
            // 获取当前数字在map中的出现次数
            int count = map.getOrDefault(i, 0);
            // 如果出现两次,说明是重复的数字
            if (count == 2) {
                errorNums[0] = i;
            } 
            // 如果未出现,说明是缺失的数字
            else if (count == 0) {
                errorNums[1] = i;
            }
        }

        // 返回包含两个错误数字的数组
        return errorNums;
    }
}

在代码中,

  • getOrDefault(i, 0): 是**HashMap** 类的一个方法,用于获取键 i 的值。
    • i:是要查找的键。
    • 0:是如果键 i 不存在于 map 中时返回的默认值。
  • map.put(num, map.getOrDefault(num, 0) + 1);用来存储每个元素出现的次数。

复杂度:

  • 时间复杂度:O(n),其中 n 是数组 nums 的长度。

  • **空间复杂度:**O(n)。

相关推荐
信奥卷王8 小时前
[GESP202609 六级] 分树规划
算法
夏幻灵8 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
徐小黑ACG10 小时前
Golang 基础05 结构体struct
开发语言·算法·golang
Navigator_Z10 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
北极有牛11 小时前
cpp学习笔记--常量指针
java·开发语言·算法
GPU实战笔记11 小时前
云端 GPU 训练的账户余额提醒:它能说明什么,不能说明什么?
深度学习·算法·成本管理·gpu云计算·云端训练
浮链序11 小时前
怎么证明"你这个模型是偷我的"——把蒸馏变成取证工具
算法·安全·llm
小O的算法实验室11 小时前
IEEE TMC,面向异构物联网的多目标量子行为拓扑优化算法
算法
圣保罗的大教堂12 小时前
leetcode 301. 删除无效的括号 困难
leetcode